/* kcode.c: (C) TOYODA Eizi, 1994
 * kanzi code determination
 */

#include <stdio.h>
#include <ctype.h>
#include <string.h>

#define		ESC				(0x1b)
#define		ESCSEQMAX		256

#define	streq(s,st)	(strcmp(s,st) == 0)

typedef unsigned char		byte;

	int
ResolveEscSeq(seq, seqlen)
	byte		*seq;
	int			seqlen;
{
	seq[seqlen] = '\0';
	if (seqlen == 1) {
		return 0;
	} else if (seqlen == 2) {
/*###25 [lint] strcmp arg 1 ) llib-lc(710) :: kcode.c(25)%%%*/
		if (streq(seq, "\033K"))
			return 'k';
/*###27 [lint] strcmp arg 1 ) llib-lc(710) :: kcode.c(27)%%%*/
		if (streq(seq, "\033H"))
			return 'k';
	} else if (seqlen == 3) {
/*###30 [lint] strcmp arg 1 ) llib-lc(710) :: kcode.c(30)%%%*/
		if (streq(seq, "\033$@"))
			return 'B';
/*###32 [lint] strcmp arg 1 ) llib-lc(710) :: kcode.c(32)%%%*/
		if (streq(seq, "\033$B"))
			return 'b';
/*###34 [lint] strcmp arg 1 ) llib-lc(710) :: kcode.c(34)%%%*/
		if (streq(seq, "\033$A"))
			return 'A';
/*###36 [lint] strcmp arg 1 ) llib-lc(710) :: kcode.c(36)%%%*/
		if (streq(seq, "\033$C"))
			return 'C';
/*###38 [lint] strcmp arg 1 ) llib-lc(710) :: kcode.c(38)%%%*/
		if (streq(seq, "\033&@"))
			return '&';
/*###40 [lint] strcmp arg 1 ) llib-lc(710) :: kcode.c(40)%%%*/
		if (streq(seq, "\033(H"))
			return 'h';
/*###42 [lint] strcmp arg 1 ) llib-lc(710) :: kcode.c(42)%%%*/
		if (streq(seq, "\033(I"))
			return 'i';
	} else if (seqlen == 4) {
/*###45 [lint] strcmp arg 1 ) llib-lc(710) :: kcode.c(45)%%%*/
		if (streq(seq, "\033($@"))
			return 'B';
/*###47 [lint] strcmp arg 1 ) llib-lc(710) :: kcode.c(47)%%%*/
		if (streq(seq, "\033($A"))
			return 'A';
/*###49 [lint] strcmp arg 1 ) llib-lc(710) :: kcode.c(49)%%%*/
		if (streq(seq, "\033($B"))
			return 'b';
/*###51 [lint] strcmp arg 1 ) llib-lc(710) :: kcode.c(51)%%%*/
		if (streq(seq, "\033($C"))
			return 'C';
/*###53 [lint] strcmp arg 1 ) llib-lc(710) :: kcode.c(53)%%%*/
		if (streq(seq, "\033($D"))
			return 'D';
/*###55 [lint] strcmp arg 1 ) llib-lc(710) :: kcode.c(55)%%%*/
		if (streq(seq, "\033($E"))
			return 'E';
/*###57 [lint] strcmp arg 1 ) llib-lc(710) :: kcode.c(57)%%%*/
		if (streq(seq, "\033($F"))
			return 'F';
/*###59 [lint] strcmp arg 1 ) llib-lc(710) :: kcode.c(59)%%%*/
		if (streq(seq, "\033($G"))
			return 'G';
/*###61 [lint] strcmp arg 1 ) llib-lc(710) :: kcode.c(61)%%%*/
		if (streq(seq, "\033($I"))
			return 'I';
/*###63 [lint] strcmp arg 1 ) llib-lc(710) :: kcode.c(63)%%%*/
		if (streq(seq, "\033($J"))
			return 'J';
/*###65 [lint] strcmp arg 1 ) llib-lc(710) :: kcode.c(65)%%%*/
		if (streq(seq, "\033($K"))
			return 'K';
/*###67 [lint] strcmp arg 1 ) llib-lc(710) :: kcode.c(67)%%%*/
		if (streq(seq, "\033($L"))
			return 'L';
/*###69 [lint] strcmp arg 1 ) llib-lc(710) :: kcode.c(69)%%%*/
		if (streq(seq, "\033($M"))
			return 'M';
	};
	if (seq[seqlen-1] >= '@') {
		return '?';
	}
	return 0;
}

#define is_ms1st(c) ((0x81 <= c) && (c <= 0x9F) || (0xE0 <= c) && (c <= 0xEF))

	int
FileCode(input)
	FILE		*input;
{
	int		c;
	int		i, j;
	int		total = 0;				/* total bytes */
	/* ESC sequence handling */
	int		esc_cnt = 0;			/* 0: normal text, else seq length */
	byte	esc_seq[ESCSEQMAX]; 	/* ESC sequence buffer */
	while ((c = getc(input)) != EOF) {
		total++;
		if (c == ESC || esc_cnt) {
			int		r;
			esc_seq[esc_cnt] = c;
			esc_cnt++;
			if ((r = ResolveEscSeq(esc_seq, esc_cnt)) || esc_cnt == ESCSEQMAX)
				esc_cnt = 0;
			if ((r != 0) && (r != '?'))
				return r;
		} else if (c & 0x80) {
			if (is_ms1st((byte)c))
				return 's';
			else if (isgraph(c & 0x7f))
				return 'e';
		}
	}
	return 0;
}

	void
FileLoop(input, fnam)
	FILE		*input;
	char		*fnam;
{
	int			r;
	if (!streq(fnam, ""))
		printf("%s: ", fnam);
	r = FileCode(input);
	if (r == 'b')
		puts("jis X 0208-1983");
	else if (r == '&')
		puts("jis X 0208-1990");
	else if (r == 'B')
		puts("jis C 6226-1978");
	else if (r == 'A')
		puts("GB 2312-80");
	else if (r == 'C')
		puts("KS C 5601-1987");
	else if (r == 'D')
		puts("JIS X 0212-1990");
	else if (r == 'E')
		puts("GB 2312-80 + GB 8565-88");
	else if (r == 'F')
		puts("Blissymbol");
	else if (r == 'G')
		puts("CNS 11643-1986 plane 1");
	else if (r == 'H')
		puts("CNS 11643-1986 plane 2");
	else if (r == 'I')
		puts("CNS 11643-1992 plane 1");
	else if (r == 'J')
		puts("CNS 11643-1992 plane 2");
	else if (r == 'K')
		puts("CNS 11643-1992 plane 3");
	else if (r == 'L')
		puts("CNS 11643-1992 plane 4");
	else if (r == 'M')
		puts("CNS 11643-1992 plane 5");
	else if (r == 'i')
		puts("jis X 0201 katakana");
	else if (r == 'h')
		puts("sweden");
	else if (r == 'k')
		puts("nec");
	else if (r == 's')
		puts("ms-kanzi");
	else if (r == 'e')
		puts("euc");
	else
		puts("ascii");
}

	void
FileName(fnam)
	char		fnam[];
{
	FILE		*input;
	if (streq(fnam, "") || streq(fnam, "-")) {
		input = stdin;
	} else {
		if ((input = fopen(fnam, "rt")) == NULL) {
			(void)perror(fnam);
			return;
		}
	}
	FileLoop(input, fnam);
	fclose(input);
}

	int
main(argc, argv)
	int			argc;
	char		*argv[];
{
	int			i;
	int			nof = 0;
	for (i=1; i<argc; i++) {
		FileName(argv[i]);
		nof++;
	}
	if (nof == 0)
		FileName("");
	return 0;
}
